* ------------------------------------------------------
*  Reset- and Interrupt-Vectors

; The following are interrupt vectors used by the VMU hardware.  DO NOT
; CHANGE ANY OF THEM.
;
; .org <address> means that the code following the .org directive starts
; at the given address.  For example
;
;      .org 200
;
;      XOR ACC
;
; means that 'XOR ACC' will be placed at memory offset $200 in the program,

       .org    0
       jmpf    start           ; far jump to the start of the main program

       .org    $3
       jmp     nop_irq

       .org    $b
       jmp     nop_irq

       .org    $13
       jmp     nop_irq

       .org    $1b
       jmp     t1int

       .org    $23
       jmp     nop_irq

       .org    $2b
       jmp     nop_irq

       .org    $33
       jmp     nop_irq

       .org    $3b
       jmp     nop_irq

       .org    $43
       jmp     nop_irq

       .org    $4b
       clr1    p3int,0
       clr1    p3int,1

nop_irq:
       reti

* ------------------------------------------------------
*  Flash Memory R/W Hardware Interupts

; means that 'XOR ACC' will be placed at memory offset $200 in the program,


; Flash memory write external program - Not needed under normal operation

	.org $100
fm_wrt_ex:
	not1    ext,0
	jmpf    fm_wrt_ex
	reti

; Flash memory verify external program - Not needed under normal operation

	.org $110
fm_vrf_ex:
	not1    ext,0
	jmpf    fm_vrf_ex
	reti

; Flash memory page read external program - Not needed under normal operation

	.org $120
fm_prd_ex:
	not1    ext,0
	jmpf    fm_prd_ex
	reti

       .org    $130
t1int:
       push    ie
       clr1    ie,7
       not1    ext,0
       jmpf    t1int
       pop     ie
       reti

       .org    $1f0
goodbye:
       not1    ext,0
       jmpf    goodbye         ; leave game mode
