; Useful definitions for input

DPAD_UP EQU 0
DPAD_DOWN EQU 1
DPAD_LEFT EQU 2
DPAD_RIGHT EQU 3
BUTTON_A EQU 4
BUTTON_B EQU 5

; The following are input subroutines.

* ----------------------------------------------------------------------
* getkeys - loads Port 3 data into ACC
*           also handles Mode-button (QUIT), Dreamcast Connect and Sleep

getkeys:
       bp p7,0,quit            ; Quit, if Dreamcast Connection
       ld p3                   ; read key status
       bn acc,6,quit           ; if Mode Key pressed, Quit
       bn acc,7,sleep          ; if Sleep Key pressed, then Pause
       ret                     ; otherwise return with pressed key in ACC
quit:
       jmp goodbye             ; Long Jump, in case we are too far away
                               ; for a 'normal' branch
sleep:
       set1 pcon,0             ; activate HALT mode (saves power)
       bn p3,7,sleep           ; wait until Sleep Key is released
       mov #0,vccr             ; turn off LCD
       ;
sleepmore:
       set1 pcon,0             ; activate HALT mode (saves power)
       bp p7,0,quit            ; Docked?
       bp p3,7,sleepmore       ; no Sleep Key pressed yet
       mov #$80,vccr           ; turn on LCD again
       ;
waitsleepup:
       set1 pcon,0             ; activate HALT modus (saves power)
       bn p3,7,waitsleepup
       br getkeys              ; continue to wait for keypress
