* ------------------------------------------------------
*  Special Function Registers

       .include "sfr.i"

* ------------------------------------------------------
*  Variable-Definitions

osc_rc EQU 77
osc_rcfw EQU 205
osc_xt EQU 239

LowBattChk EQU 110

fmflag EQU 124
fmbank EQU 125
fmadd_h EQU 126
fmadd_l EQU 127

fmbuff EQU 128

* ------------------------------------------------------
*  Interupt Vectors

	.include "libraries/f_intvec.i"

* ------------------------------------------------------
*  Game Data

	.include "data/gamehdr.i"
	.include "data/iconanm.i"
	.include "data/iconplt.i"
	.include "data/icondat.i"

* ------------------------------------------------------
*  Main Program Loop

	.include "libraries/main.i"

* ------------------------------------------------------
*  Jump To User Program

	;jmp begin

* ------------------------------------------------------
*  User Defined Imports


* ------------------------------------------------------
*  User Defined Program

begin:
	call cls

loop0:
	ld P3
	bn acc, 6, .finish
	call ChkBatt
	bz loop0
	call prepare
	call WriteData
.finish:
	call finish

finish:
	jmpf goodbye

prepare:
	push PSW
	set1 PSW, 1
	mov #fmbuff, 0
	mov #128, c
	mov #$10, b
loop4:
	ld b
	st @r0
	inc b
	inc 0
	dec c
	ld c
	bnz loop4
	pop PSW
	ret

ChkBatt:
	ld P7
	bn acc, 1, next3
	mov #0, acc
	ret

next3:
	mov #$ff, acc
	ret

WriteData:
	push PSW
	set1 PSW, 1
	mov #0, fmbank
	mov #>fmarea, fmadd_h
	mov #<fmarea, fmadd_l
	mov #0, fmflag
	clr1 PSW, 1
	mov #$ff, acc
	st LowBattChk
	
	pop PSW
	push OCR
	mov #osc_rc, OCR
	call fm_wrt_ex
	pop OCR
	
	push PSW
	clr1 PSW, 1
	mov #0, acc
	st LowBattChk
	pop PSW
	ret

cls:
	push OCR
	mov #osc_rc, OCR
	mov #0, XBNK
	call cls_s
	mov #1, XBNK
	call cls_s
	pop OCR
	ret

cls_s:
	mov #$80, 2
	mov #$80, b
loop3:
	mov #0, @r2
	inc 2
	dbnz b, loop3
	ret

fmarea:
	.byte 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	.byte 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	.byte 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	.byte 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	.byte 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	.byte 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	.byte 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	.byte 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0

* ------------------------------------------------------
*  End Program

	.include "libraries/endprog.i"

